// ----------------------------------------------------------------------
// fobOp^C}[\WindowNX
// ----------------------------------------------------------------------
// ȓe
// Ex̕\s
// ES̓10%𒴂ꍇɂ͐ԐFŕ\
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn.h>
#include	<nn/gx.h>
#include	<nn/math.h>
#include	<nn/os.h>
#include	<nn/hid.h>
#include	<nn/fnd.h>
#include	<nn/fs.h>

#include	<string.h>

// ----------------------------------------------------------------------
// include original header
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlGraphics.h"
#include	"TxtWindow.h"
#include	"TxtWinDebugTimer.h"

// ----------------------------------------------------------------------
//CTxtWinDebugTimer::CTxtWinDebugTimer
// ----------------------------------------------------------------------
// e
//   RXgN^
// ----------------------------------------------------------------------
// 
//   max_timer	[ I ] ^C}[̌w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinDebugTimer::CTxtWinDebugTimer(int max_timer)
	: CTxtWindow("Debug Timer")
{
	int n = 0;
	for (n = 0 ; n < MAX_TIMER ; n++)
	{
		sprintf(m_str[n], "---");
		m_time_st[n] = 0;
		m_time[n]	 = 0;
	}

	m_max_timer = max_timer;
}

// ----------------------------------------------------------------------
// CTxtWinDebugTimer::~CTxtWinDebugTimer
// ----------------------------------------------------------------------
// e
//   fXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinDebugTimer::~CTxtWinDebugTimer()
{
}

// ----------------------------------------------------------------------
// CTxtWinDebugTimer::Draw
// ----------------------------------------------------------------------
// e
//   Window̕\s܂B
// ----------------------------------------------------------------------
// 
//   graphics		[ I ] `NXw肵܂B 
//   display		[ I ] `悷fBXvCw肵܂B
//   sx				[ I ] `JnXWw肵܂B
//   sy				[ I ] `IYWw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   0Ԃ܂B
// ----------------------------------------------------------------------
int CTxtWinDebugTimer::Draw(CCtrlGraphics* graphics, const s32 display, int sx, int sy)
{
	char	str[128];
	int		n	= 0;
	unsigned long	sum = 0;
	float	per = 0.0f;

	for (n = 0 ; n < 9 ;n++)
	{
		sum+= m_time[n];
	}

	CTxtWindow::SetLines(12);

#if defined( TIME_SET_MSEC )
	sprintf(str, "title              [   ms]:per\n");
#else
	sprintf(str, "title              [   us]:per\n");
#endif
	CTxtWindow::SetText(0, str, 0.0, 0.0, 0.0);

	sprintf(str, "------------------------------\n");
	CTxtWindow::SetText(1, str, 1.0, 1.0, 1.0);

	for (n = 0 ; n < m_max_timer ; n++)
	{
		per = (float)m_time[n] / (float)sum * 100.0f;
		sprintf(str, "%02d:%s [%5d]:%4.2f\n", n + 1, m_str[n], m_time[n], per);

		if (per > 10.0f)
		{
			// 10%𒴂ꍇɂ͐ԕ\
			CTxtWindow::SetText(n + 2, str, 1.0, 0.0, 0.0);
		}
		else
		{
			// ͍̑\
			CTxtWindow::SetText(n + 2, str, 0.0, 0.0, 0.0);
		}
	}

	// Zp[^[
	sprintf(str, "------------------------------\n");
	CTxtWindow::SetText(n + 2, str, 1.0, 1.0, 1.0);

	// v̕\
	sprintf(str, "All                [%5d]\n", m_time_all);
	CTxtWindow::SetText(n + 3, str, 0.0, 0.0, 0.0);

	CTxtWindow::DrawWindow(graphics, display, sx, sy);
	return 0;
}

// ----------------------------------------------------------------------
// CTxtWinDebugTimer::SetTimerText
// ----------------------------------------------------------------------
// e
//   ڂ̃^Cgݒ肵܂B
// ----------------------------------------------------------------------
// 
//   no			[ I ] ԍw肵܂B
//   str		[ I ] ^Cgw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWinDebugTimer::SetTimerText(int no, char* str)
{
	if (no < 0 || no >= m_max_timer)
	{
		return;
	}
	sprintf(m_str[no], str);
}

// ----------------------------------------------------------------------
// CTxtWinDebugTimer::TimerStart
// ----------------------------------------------------------------------
// e
//   w肳ꂽԍ̃^C}[N܂B
// ----------------------------------------------------------------------
// 
//   no			[ I ] ԍw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWinDebugTimer::TimerStart(int no)
{
	if (no < 0 || no >= m_max_timer)
	{
		return;
	}
	m_time_st[no] = CTR_GetTick();
}

// ----------------------------------------------------------------------
// CTxtWinDebugTimer::TimerEnd
// ----------------------------------------------------------------------
// e
//   w肳ꂽԍ̃^C}[I܂B
// ----------------------------------------------------------------------
// 
//   no			[ I ] ԍw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWinDebugTimer::TimerEnd(int no)
{
	if (no < 0 || no >= m_max_timer)
	{
		return;
	}
	m_time[no] = CTR_GetTick() - m_time_st[no];
}

// ----------------------------------------------------------------------
// CTxtWinDebugTimer::TimerAllStart
// ----------------------------------------------------------------------
// e
//   B̍vp^C}[N܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWinDebugTimer::TimerAllStart()
{
	m_time_all_st = CTR_GetTick();
}

// ----------------------------------------------------------------------
// CTxtWinDebugTimer::TimerAllEnd
// ----------------------------------------------------------------------
// e
//   B̍vp^C}[I܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWinDebugTimer::TimerAllEnd()
{
	m_time_all = CTR_GetTick() - m_time_all_st;
}
