// ----------------------------------------------------------------------
// oʕ\EChENX
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn.h>
#include	<nn/gx.h>
#include	<nn/math.h>
#include	<nn/os.h>
#include	<nn/hid.h>
#include	<nn/fnd.h>
#include	<nn/fs.h>

#include	<string.h>

// ----------------------------------------------------------------------
// include hgr header
// ----------------------------------------------------------------------
#include	"hgr.h"					// hgrwb_[
using namespace mw::hgr;

// ----------------------------------------------------------------------
// include original header
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlGraphics.h"
#include	"CtrlCamera.h"
#include	"TxtWindow.h"
#include	"TxtWinResultHgr.h"

// ----------------------------------------------------------------------
// CTxtWinResultHgr::CTxtWinResultHgr
// ----------------------------------------------------------------------
// e
//   RXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinResultHgr::CTxtWinResultHgr()
	: CTxtWindow("Result")
{

}

// ----------------------------------------------------------------------
// CTxtWinResultHgr::~CTxtWinResultHgr
// ----------------------------------------------------------------------
// e
//   fXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinResultHgr::~CTxtWinResultHgr()
{
}

// ----------------------------------------------------------------------
// CTxtWinResultHgr::Draw
// ----------------------------------------------------------------------
// e
//   Window̕\s܂B
// ----------------------------------------------------------------------
// 
//   graphics		[ I ] OtBbNNXw肵܂B
//   display		[ I ] Window\fBXvCw肵܂B
//   sx				[ I ] Window\XWw肵܂B
//   sy				[ I ] Window\YWw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   0Ԃ܂B
// ----------------------------------------------------------------------
int CTxtWinResultHgr::Draw(CCtrlGraphics* graphics, const s32 display, int sx, int sy)
{
	char		str[64];
	int			n			= 0;
	int			finger_num	= m_result.fingernum;
	PSPoint*	fpoint		= m_result.fpoint;
	unsigned short* fdir	= m_result.fdir;
	s32*		fleng		= m_result.fleng;
	int			lines		= 12;

	if (finger_num + 2 > lines)
	{
		lines = finger_num + 2; 
	}

	CTxtWindow::SetLines(lines);
	
	sprintf(str, "feanum:%d\n", finger_num);
	CTxtWindow::SetText(0, str, 0.0, 0.0, 0.0);

	sprintf(str, "------------------------------\n");
	CTxtWindow::SetText(1, str, 1.0, 1.0, 1.0);

	for (n = 0 ; n < finger_num ; n++)
	{
		sprintf(str,"[%3d] (%3d, %3d)  DIR = %3d Len = %3d\n", n, (int)fpoint->x, (int)fpoint->y ,(int)*fdir, (int)*fleng);
		CTxtWindow::SetText(n + 2, str, 0.0, 0.0, 0.0);

		fpoint++;
		fdir++;
		fleng++;
	}

	for (; n < 10 ; n++)
	{
		sprintf(str,"[%3d] (---, ---)  DIR = --- Len = ---\n", n);
		CTxtWindow::SetText(n + 2, str, 0.0, 0.0, 0.0);
	}

	CTxtWindow::DrawWindow(graphics, display, sx, sy);

	return 0;
}

// ----------------------------------------------------------------------
// CTxtWinResultHgr::UpdateResult
// ----------------------------------------------------------------------
// e
//   ʒl̍XVs܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWinResultHgr::UpdateResult(HGResult* result)
{
	memcpy(&m_result, result, sizeof(HGResult));
}
